#region Copyright Syncfusion Inc. 2001 - 2006
//
//  Copyright Syncfusion Inc. 2001 - 2006. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Chart;

namespace RealMode3DChartSample
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
        private Syncfusion.Windows.Forms.Chart.ChartControl chartControl1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		private void InitializeControlSettings()
		{
			this.chartControl1.Font = new System.Drawing.Font("Arial", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));

			// Specify a ChartPalette:
			Color[] color = new Color[]{Color.FromArgb(115, 73,141,238),Color.FromArgb(115,186,66,30), Color.FromArgb(115,247,179,78), Color.FromArgb(115,242,19,78)};
			this.chartControl1.Palette = ChartColorPalette.Custom ;

			this.chartControl1.Model.ColorModel.CustomColors = color;
			this.chartControl1.Palette = ChartColorPalette.Custom ;

			this.chartControl1.ChartInterior = new Syncfusion.Drawing.BrushInfo(185,new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.Vertical, Color.LightBlue , Color.Azure));
			this.chartControl1.LegendPosition = ChartDock.Top;
		}

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			InitializeControlSettings();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(Form1));
            this.chartControl1 = new Syncfusion.Windows.Forms.Chart.ChartControl();
            this.SuspendLayout();
            // 
            // chart
            // 
            this.chartControl1.BackInterior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.Vertical, System.Drawing.Color.FromArgb(((int)(((byte)(203)))), ((int)(((byte)(209)))), ((int)(((byte)(226))))), System.Drawing.Color.FromArgb(((int)(((byte)(227)))), ((int)(((byte)(232)))), ((int)(((byte)(243))))));
            // 
            // 
            // 
            this.chartControl1.ChartArea.AxesSideBySide = true;
            this.chartControl1.ChartArea.BackInterior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.Vertical, System.Drawing.Color.FromArgb(((int)(((byte)(203)))), ((int)(((byte)(209)))), ((int)(((byte)(226))))), System.Drawing.Color.FromArgb(((int)(((byte)(227)))), ((int)(((byte)(232)))), ((int)(((byte)(243))))));
            this.chartControl1.ChartInterior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.Horizontal, System.Drawing.Color.FromArgb(((int)(((byte)(203)))), ((int)(((byte)(209)))), ((int)(((byte)(226))))), System.Drawing.Color.FromArgb(((int)(((byte)(227)))), ((int)(((byte)(232)))), ((int)(((byte)(243))))));
            this.chartControl1.Dock = System.Windows.Forms.DockStyle.Fill;
                          
            // No legend needed
            this.chartControl1.Legend.Visible = false;
            this.chartControl1.ShowLegend = false;

            this.chartControl1.Location = new System.Drawing.Point(0, 0);
            this.chartControl1.Name = "chart";
            this.chartControl1.Palette = Syncfusion.Windows.Forms.Chart.ChartColorPalette.Default;
            this.chartControl1.PrimaryXAxis.LabelAligment = System.Drawing.StringAlignment.Center;
            this.chartControl1.PrimaryXAxis.Orientation = Syncfusion.Windows.Forms.Chart.ChartOrientation.Horizontal;
            this.chartControl1.PrimaryYAxis.LabelAligment = System.Drawing.StringAlignment.Center;
            
            this.chartControl1.Size = new System.Drawing.Size(1400, 700);
            this.chartControl1.TabIndex = 0;
            this.chartControl1.Text = "3D column chart tutorial";
            this.chartControl1.ToolBar.Location = new System.Drawing.Point(0, 0);
            this.chartControl1.ChartFormatAxisLabel += new ChartFormatAxisLabelEventHandler(chartControl1_ChartFormatAxisLabel);
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(1400, 700);
            this.Controls.Add(this.chartControl1);
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.Name = "";
            this.Text = "";
            this.Load += new System.EventHandler(this.Form1_Load);
            this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			InitializeChartData();
			InitializeChartAppearance();            
		}

		/// <summary>
		/// Initializes Chart Data.
		/// </summary>
		protected void InitializeChartData()
		{

            #region Add series
            ChartSeries series = this.chartControl1.Model.NewSeries("Serie 1",ChartSeriesType.Column);
			series.Name = "0";

			series.Points.Add(0,12);
			series.Points.Add(1,14);
			series.Points.Add(2,16);
			series.Points.Add(3,18);
			series.Points.Add(4,20);


			this.chartControl1.Series.Add(series);

			series = this.chartControl1.Model.NewSeries("Serie 2",ChartSeriesType.Column);
			series.Name = "1";

			series.Points.Add(0,22);
			series.Points.Add(1,24);
			series.Points.Add(2,26);
			series.Points.Add(3,28);
			series.Points.Add(4,30);


			this.chartControl1.Series.Add(series);

			series = this.chartControl1.Model.NewSeries("Serie 3",ChartSeriesType.Column);
			series.Name = "2";

			series.Points.Add(0,32);
			series.Points.Add(1,34);
			series.Points.Add(2,36);
			series.Points.Add(3,38);
			series.Points.Add(4,40);


			this.chartControl1.Series.Add(series);

			series = this.chartControl1.Model.NewSeries("Serie 4",ChartSeriesType.Column);
			series.Name = "3";

            series.Points.Add(0, 42);
            series.Points.Add(1, 44);
            series.Points.Add(2, 46);
            series.Points.Add(3, 48);
            series.Points.Add(4, 50);


			this.chartControl1.Series.Add(series);

			series = this.chartControl1.Model.NewSeries("Serie 5",ChartSeriesType.Column);
			series.Name = "4";

            series.Points.Add(0, 52);
            series.Points.Add(1, 54);
            series.Points.Add(2, 56);
            series.Points.Add(3, 58);
            series.Points.Add(4, 60);

			this.chartControl1.Series.Add(series);
			
            #endregion

            this.chartControl1.Series.Add(series);
		}

		/// <summary>
		/// Initializes the appearance of the chart in 3D.
		/// </summary>
		protected void InitializeChartAppearance()
		{
            this.chartControl1.ChartFormatAxisLabel += new ChartFormatAxisLabelEventHandler(chartControl1_ChartFormatAxisLabel);
            this.chartControl1.ChartAreaPaint += new PaintEventHandler(chartControl1_ChartAreaPaint);

            this.chartControl1.SpacingBetweenSeries = 50;
            this.chartControl1.HidePartialLabels = true;
            this.chartControl1.Series3D = true;
            this.chartControl1.Rotation = 45;
            this.chartControl1.Tilt = 45;
            this.chartControl1.Depth = 300;
            this.chartControl1.RealMode3D = false;
            this.chartControl1.Indexed = true;


            // Z-Axis. Labels are on right side, but when I later set X-axis inversed then labels are on wrong side! 
            // How to add lines along series points that clarify chart more than with out?
            foreach (ChartSeries seriesn in this.chartControl1.Series)
            {
                seriesn.DrawSeriesNameInDepth = true;
                seriesn.SeriesNameOXAngle = 0;               
            }            

            // X-Axis
            // Had to be inversed, but labels are now on wrong side! 
            this.chartControl1.PrimaryXAxis.Inversed = false; 
			this.chartControl1.PrimaryXAxis.RangeType = ChartAxisRangeType.Set;
			this.chartControl1.PrimaryXAxis.Range = new MinMaxInfo(0,5,1);
            this.chartControl1.PrimaryXAxis.ForceZero = true;
            this.chartControl1.PrimaryXAxis.PreferZero = true;
            this.chartControl1.PrimaryXAxis.Title = "X-axis";

            this.chartControl1.PrimaryYAxis.RangeType = ChartAxisRangeType.Set;
            this.chartControl1.PrimaryYAxis.Range = new MinMaxInfo(0, 70, 10);
            this.chartControl1.PrimaryYAxis.Title = "Y-axis";
		}

        void chartControl1_ChartAreaPaint(object sender, PaintEventArgs e)
        {
            ChartArea chartArea = sender as ChartArea;
            if (chartArea == null) return;
            //83, 633
            for (int i = 0; i < this.chartControl1.Series.Count; i++)
            {                
                ChartSeries ser = this.chartControl1.Series[i];
                int x1 = (int)(i * 45 - 2.5 * i) + (int)this.chartControl1.PrimaryXAxis.Location.X;
                int x2 = x1 + 1075;
                int y = (int)this.chartControl1.PrimaryXAxis.Location.Y - (int)(i * 45 - 2.5 * i);
                Pen pen = new Pen(Brushes.Black);
                pen.DashStyle = System.Drawing.Drawing2D.DashStyle.Dash;
                e.Graphics.DrawLine(pen, new Point(x1, y), new Point(x2, y));
            }                        
        }

        void chartControl1_ChartFormatAxisLabel(object sender, ChartFormatAxisLabelEventArgs e)
        {
            // X Axis
            if (e.IsAxisPrimary && e.AxisOrientation == ChartOrientation.Horizontal)
            {
                // Restrictions
                if (e.Value > 4 || e.Value < 0) e.Label = "";
                else e.Label = ((double)(4 - e.Value)).ToString();
            }
            // Y Axis
            else if (e.IsAxisPrimary && e.AxisOrientation == ChartOrientation.Vertical)
            {
                e.Label = e.Value.ToString() + ".0";
            }            

            e.Handled = true;
        }
    
	}
}